# Modelo de la cámara obscura
# Necesitamos:
#  las coordenadas de la cámara
#  el punto del objeto donde ve la cámara
#  al vector de arriba
# Se los pasamos al programa en la línea de comandos

import sys
import numpy as np
import cubo

n = len( sys.argv )
if n != 10 :
	print("Args: cx cy cz  ox oy oz  ax ay az" )
	sys.exit(1)

vc = np.zeros( (3,1) )
vc[0,0] = float( sys.argv[1] )
vc[1,0] = float( sys.argv[2] )
vc[2,0] = float( sys.argv[3] )

vo = np.zeros( (3,1) )
vo[0,0] = float( sys.argv[4] )
vo[1,0] = float( sys.argv[5] )
vo[2,0] = float( sys.argv[6] )

va = np.zeros( (3,1) )
va[0,0] = float( sys.argv[7] )
va[1,0] = float( sys.argv[8] )
va[2,0] = float( sys.argv[9] )

vv = vc - vo
vz = vv/np.linalg.norm( vv, axis=0 )

vv = np.cross( va, vz, axisa=0, axisb=0, axisc=0 )
vx = vv/np.linalg.norm( vv, axis=0 )

vy = np.cross( vz, vx, axisa=0, axisb=0, axisc=0 )

R = np.zeros( (3,3) )
R[0,:] = vx.T
R[1,:] = vy.T
R[2,:] = vz.T

# print( R )

Cubo = cubo.hace_cubo( 4, 1, 2 )

K = np.zeros( (3,3) )
K[0,0] = -1000
K[0,2] = 200
K[1,1] = -1000
K[1,2] = 150
K[2,2] = 1.0

# print( K )

p = cubo.proyecta( Cubo, K, R, -vc )

cubo.dibuja( p )

